#ifndef DMA_DRIVERLIB_H
#define DMA_DRIVERLIB_H
// Header file for Belle 2 DMA low-level functions with PCIe40

/// Open DMA
int dma_open( int fd ) ;

/// Open DMA
int dma_close( int fd ) ;

/// Initialize DMA
int dma_initialize( int fd ) ;

/// reset spages addresses
int pcie40_resetSPages( int fd ) ; 

/// Start DMA
int pcie40_start_dma( int fd ) ;

/// Get a pointer to super page
unsigned int * pcie40_getSuperPagePointer( int link , int spage , int slot ) ;

/// Copy super page memory
unsigned int * pcie40_getSuperPageCopy( int link , int spage , int slot ) ;

/// Free super page when it is ready
int pcie40_freeSuperPage( int fd , int spage ) ;

#endif // PCIE40_B2DMA_H
